<?php

namespace app\admin\controller\user\withdrawal;

use app\common\controller\Backend;

/**
 * 用户提现
 *
 * @icon fa fa-circle-o
 */
class UserwithdrawalLog extends Backend
{

    /**
     * UserwithdrawalLog模型对象
     * @var \app\admin\model\user\withdrawal\UserwithdrawalLog
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\user\withdrawal\UserwithdrawalLog;
        $this->view->assign("statusList", $this->model->getStatusList());
        $this->view->assign("withdrawalStatusList", $this->model->getWithdrawalStatusList());
        $this->view->assign("typeList", $this->model->getTypeList());
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;

        $this->searchFields = ["id","name","bank_name","bank_user_name","id_number","user.nickname","user.realname","user.mobile"];


        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['user'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('user')->visible(['nickname','realname','mobile','avatar']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }







    /**提现审核
     * @return string
     * @throws \think\Exception
     * @throws \think\exception\DbException
     */
    public function auths($ids = ""){

        if($this->request->isPost())
        {
            try{
                $params = $this->request->post("row/a");


                $auth_status = $params["status"];
                $reason = $params["reason"];
                $model = (new \app\common\model\user\withdrawal\UserwithdrawalLog);
                $model->withdrawalReview($ids,$auth_status,$reason,true);

            }catch (\Throwable $e){
                $this->error($e->getMessage());
            }

            $this->success("已完成审核");
        }

        $row = $this->model->where(array('id'=>$ids))->find();
        if (!$row) {
            $this->error(__('No Results were found'));
        }

//        $row = $this->model->get($param['ids']);
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }





    /**确认打款
     * @return string
     * @throws \think\Exception
     * @throws \think\exception\DbException
     */
    public function paid($ids = ""){

        if($this->request->isPost())
        {
            try{
                $params = $this->request->post("row/a");


                $remark = $params["remark"];
                $real_have_price = $params["real_have_price"];
                if($real_have_price <= 0) $this->error("请输入正确的打款金额");


                $model = (new \app\common\model\user\withdrawal\UserwithdrawalLog);
                $model->paidAlready($ids,$real_have_price,$remark,true);

            }catch (\Throwable $e){
                $this->error($e->getMessage());
            }

            $this->success("已完成审核");
        }

        $row = $this->model->where(array('id'=>$ids))->find();
        if (!$row) {
            $this->error(__('No Results were found'));
        }

//        $row = $this->model->get($param['ids']);
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }


}
